program WorkBenchSuite;

//{$mode objfpc}{$H+}
{$MODE DELPHI}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  Forms, controls, treelistviewpackage, pl_dcp, lz_datetimectrls, bcmain,
  bcoptions, sysutils, windows, messages, bcsplash, AppRoutines, bcgplviewer,
  bcconstants, bcfilecopythread, Dialogs, GreyScreen, bclisteditor,
  bcBenchcheck;

{$R *.res}

var
   muCore : THandle;


begin
  Application.Title:='Pascall Work Bench Suite';
  // Register GUID as windows messages.
  CoreMessage      := RegisterWindowMessage(CoreGUID);
  BenchMessage     := RegisterWindowMessage(BenchGUID);
  ToolsMessage     := RegisterWindowMessage(ToolsGUID);
  UserInfoMessage  := RegisterWindowMessage(UserGUID);
  ManagerMessage   := RegisterWindowMessage(ManagerGUID);
  // Create application mutex with GUID
  muCore := CreateMutex(nil, True, CoreGUID);
  // If mutex already exists then broardcast windows message depending on link parameter.
  if GetLastError = ERROR_ALREADY_EXISTS then
  begin
       {Send initiate settings mode message.}
       if ParamStr(ParamCount) = '-m' then
          Windows.SendMessageTimeout(HWND_BROADCAST, ManagerMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);

       {Send initiate benchcheck mode message.}
       if ParamStr(ParamCount) = '-b' then
          Windows.SendMessageTimeout(HWND_BROADCAST, BenchMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);

       {Send initiate tool register mode message.}
       if ParamStr(ParamCount) = '-t' then
          Windows.SendMessageTimeout(HWND_BROADCAST, ToolsMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
       {Exit application.}
       Exit;
  end;

  try
     RequireDerivedFormResource := True;
     Application.Initialize;
     //Application.MainFormOnTaskBar := false;
     Application.ShowMainForm := false;
     Application.CreateForm(TMainForm, MainForm);
     {Display main form in admin mode.}
     if (Settings.RunningAdmin) or (Settings.ConfigFault) then
           {Send message to open main form.}
           Windows.SendMessageTimeout(HWND_BROADCAST, CoreMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
     Application.Run;
  finally
         CloseHandle(muCore);
  end;
end.

