unit bcconstants;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, registry, LCLIntf;

Const
     {Form title contstants.}
     BenchCheckTitle        = ' - Daily Benck Check.';
     ToolRegisterTitle      = ' - Tool Register.';
     ManagerTitle           = ' - Manager.';
     SettingsTitle          = ' - Settings.';

     {Application file name shortcuts.}
     WorkbenchEXE           = 'WorkbenchSuite.exe';
     WorkbenchConfig        = 'WorkbenchSuite.cfg';
     WorkbenchLocation      = 'WorkbenchLocation.cfg';

     {Icon filename shortcuts.}
     WorkbenchIcon          = 'WorkbenchSuite.ico';
     WorkbenchToolsIcon     = 'tools.ico';
     WorkbenchAppIcon       = 'Application.ico';
     WorkbenchManagerIcon   = 'manager.ico';

     {Desktop link filename shortcuts.}
     BenchCheckLink         = 'Workbench Benchcheck.lnk';
     WorkbenchSuiteLink     = 'Workbench Suite.lnk';
     ToolRegisterLink       = 'Workbench Tool Register.lnk';
     ManagerLink            = 'Workbench Manager.lnk';

     {Unique application numbers.}
     CoreGUID               = '396a7993-eb8a-4aa6-b96a-28f108c776ae';
     BenchGUID              = '396a7993-eb8a-4aa6-b96a-28f108c776ae' + '-bchk';
     ToolsGUID              = '396a7993-eb8a-4aa6-b96a-28f108c776ae' + '-treg';
     UserGUID               = '396a7993-eb8a-4aa6-b96a-28f108c776ae' + '-Sshift';
     ManagerGUID            = '396a7993-eb8a-4aa6-b96a-28f108c776ae' + '-man';

     {32 character 256bit AES encryption key, http://www.cryptool-online.org/ }
     Cryptkey               = 'bS&gt;M(!&gt;?D´Yyi!9(yc/PO$C9r3&lt;k%v°T';

     {System registry keys}
     RegHKLM                = HKEY_LOCAL_MACHINE;
     RegHKCU                = HKEY_CURRENT_USER;
     RegCurrentVersion      = '\Software\Microsoft\Windows NT\CurrentVersion';
     RegAutoStart           = '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run';
     RegCPU                 = '\Hardware\Description\System\CentralProcessor\0';

     {Application registry keys.}
     RegWorkBenchSuite      = '\SOFTWARE\WorkBenchSuite';

     {Application registry field names.}
     WorkBenchSuite         = 'WorkbenchSuite';
     ApplicationSettings    = 'ApplicationSettings';
     WorkBenchSettings      = 'WorkBenchSettings';

     {Application status image constants, 16pix.}
     at_good                = 7;
     at_bad                 = 8;
     at_user                = 10;
     at_error               = 11;
     at_info                = 3;

     {Settings tree list image constants, 24pixel.}
     st_null                = 0;
     st_good                = 1;
     st_bad                 = 2;
     st_env                 = 3;
     st_db                  = 4;
     st_bch                 = 7;
     st_app                 = 8;
     st_info                = 9;
     st_bool                = 14;
     st_dropdown            = 15;
     st_run                 = 16;
     st_icon                = 17;
     st_error               = 18;
     st_report              = 21;
     st_counter             = 22;
     st_tools               = 23;
     st_pass                = 24;
     st_users               = 25;
     st_man                 = 26;
     st_gene                = 27;

     {1 minute convetted to milliseconds.}
     MinMS                  = 60000;

     Dummy                  : DWORD = 0;

     {File copy list arrays.}
     copyfilelist : array [0..6] of string = ('WorkBenchSuite.exe',
                                              'gpl.txt',
                                              'gpl_full.txt',
                                              'workbenchsuite.ico',
                                              'tools.ico',
                                              'application.ico',
                                              'manager.ico');

     {Combobox item arrays.}
     cbi_appstart : array [0..1] of string = ('Run from source application directory.',
                                              'Run from host application directory.');

     cbi_yesno    : array [0..1] of string = ('Yes.', 'No.');

     cbi_launch   : array [0..2] of string = ('At random time interval after startup.',
                                              'At fixed time interval after startup.',
                                              'Never.');

     cbi_connections : array [0..1] of string = ('Direct file access.',
                                                 'SQL server access.');

     {User database SQL queries.}
     QSearchForUserByUsername              = 'SELECT * FROM employee WHERE username = :user;';

     QPostUserLoginDetails                 = 'INSERT INTO employee (Username, Firstname, Surname, EmployeeNum, RestrictAccess, UserPassword) ' +
                                             'VALUES (:user, :fname, :sname, :empnum, :res, :pword);';

     {Daily workbench check database queries.}

     QSearchForTodaysUserCheck             = 'SELECT * FROM dailycheck WHERE location = :loc AND username = :uname AND startdate = :date;';

     QPostStartOfShiftDAta                 = 'INSERT INTO dailycheck (username, location, startdate, tools, consumables, esdstraps, esdbench, ' +
                                             'esdjacket, startfod, extraction) VALUES (:user, :loc, :sdate, :ctools, :ccons, :cstraps, :cbench, ' +
                                             ':cjack, :csfod, :cext);';

     QUpdateEndOfShiftData                 = 'UPDATE dailycheck SET equipment = :equip, endfod = :efod, wip = :ewip, timecard = :tcard, eoscomplete = :eos ' +
                                             'WHERE location = :loc AND username = :uname AND startdate = :sdate;';

     {Tools database SQL queries.}
     QSearchForWorbenchenchTools           = 'SELECT * FROM toolregister WHERE location = :loc;';

     QSearchForWorkbenchExtraction         = 'SELECT * FROM toolregister WHERE location = :loc AND type = :ext;';

     QSearchForToolItem                    = 'SELECT * FROM toolregister WHERE location = :loc AND toolid = :tool;';

     QDeleteToolItem                       = 'DELETE FROM toolregister WHERE location = :loc AND toolid = :tool;';

     QGetToolTypeList                      = 'SELECT DISTINCT type FROM toolregister;';

     QGetToolDescriptionsList              = 'SELECT DISTINCT description FROM toolregister WHERE type = :type;';

     QGetToolSettingsList                  = 'SELECT DISTINCT setting FROM toolregister WHERE description = :des;';

     QPostNewToolRecord                    = 'INSERT INTO toolregister (location, toolid, type, description, setting, calibrated, caldate, duedate) ' +
                                             'VALUES (:loc, :toolid, :type, :des, :set, :cal, :caldate, :due);';

     QUpdateToolRecord                     = 'UPDATE toolregister SET type = :type, description = :des, setting = :set, calibrated = :cal, caldate = :caldate, duedate = :due ' +
                                             'WHERE location = :loc AND toolid = :toolid;';

     {Workbench database SQL queries.}
     QSearchForWorkbenchConsumables        = 'SELECT * FROM consumables WHERE location = :loc;'; 

     QDeleteConsumableItem                 = 'DELETE FROM consumables WHERE location = :loc AND partnumber = :part And batchnumber = :bat;';

     {Global queries.}


implementation

end.

