unit bcgplviewer;

//{$mode objfpc}{$H+}
{$MODE DELPHI}

interface

uses
  Classes, SysUtils, FileUtil, ECEditBtns, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Menus;


type

  { TGPLForm }

  TGPLForm = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    ExitButton: TECSpeedBtn;
    Image1: TImage;
    Image2: TImage;
    MainMenu1: TMainMenu;
    Memo: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    TabControl: TTabControl;
    procedure ExitButtonClick(Sender: TObject);
    procedure ExitButtonMouseEnter(Sender: TObject);
    procedure ExitButtonMouseLeave(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure LoadMemo(f: string);
    procedure TabControlChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  GPLForm: TGPLForm;

const
     generalGPL = 'gpl.txt';
     fullGPL    = 'gpl_full.txt';

implementation

{$R *.lfm}

uses
    bcmain, bcoptions, bcconstants, GreyScreen;

{ TGPLForm }

procedure TGPLForm.ExitButtonClick(Sender: TObject);
begin
     Close;
end;

procedure TGPLForm.ExitButtonMouseEnter(Sender: TObject);
begin
     ExitButton.ImageIndex:= 1;
end;

procedure TGPLForm.ExitButtonMouseLeave(Sender: TObject);
begin
     ExitButton.ImageIndex:= 0;
end;

procedure TGPLForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     StayOnTop(GPLForm, false);
end;

procedure TGPLForm.FormShow(Sender: TObject);
begin
     {Set form title bar.}
     Caption := Application.Title;
     {Make form stayontop if form highlighting enabled.}
     if Settings.GreyScreenIndex = 0 then StayOnTop(GPLForm, true);
     {Load GPL file if exists in application directory}
     if FileExists(Settings.RemoteDrive + Settings.RemoteDirectory + generalGPL) then
        LoadMemo(Settings.RemoteDrive + Settings.RemoteDirectory + generalGPL);
end;

procedure TGPLForm.LoadMemo(f: string);
begin
     Memo.Lines.Clear;
     Memo.Lines.LoadFromFile(f);
end;

procedure TGPLForm.TabControlChange(Sender: TObject);
begin
     if TabControl.TabIndex = 0 then
     begin
          if FileExists(Settings.RemoteDrive + Settings.RemoteDirectory + generalGPL) then
             LoadMemo(Settings.RemoteDrive + Settings.RemoteDirectory + generalGPL);
     end
     else
     if Tabcontrol.TabIndex = 1 then
     begin
          if FileExists(Settings.RemoteDrive + Settings.RemoteDirectory + fullGPL) then
             LoadMemo(Settings.RemoteDrive + Settings.RemoteDirectory + fullGPL);
     end;
end;

end.

