unit bclisteditor;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, ECEditBtns, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls;

type

  { TListEditor }

  TListEditor = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    OKButton: TECSpeedBtn;
    CancelButton: TECSpeedBtn;
    Image1: TImage;
    Memo: TMemo;
    Panel1: TPanel;
    procedure CancelButtonClick(Sender: TObject);
    procedure CancelButtonMouseEnter(Sender: TObject);
    procedure CancelButtonMouseLeave(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure OKButtonMouseEnter(Sender: TObject);
    procedure OKButtonMouseLeave(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  ListEditor: TListEditor;

implementation

{$R *.lfm}

uses
    bcoptions, bcconstants, bcmain, greyscreen, approutines;

{ TListEditor }

procedure TListEditor.FormShow(Sender: TObject);
var
   i      : integer;
begin
     {Update caption.}
     Caption := Application.Title;
     {Make form stayontop if form highlighting enabled.}
     if Settings.GreyScreenIndex = 0 then StayOnTop(ListEditor, true);
     {Clear memo.}
     Memo.Clear;
     {Load memo from stringlist.}
     for i := 0 to Settings.BenchLocation.Count - 1 do
         Memo.Lines.Add(DecryptString(Settings.BenchLocation[i], CryptKey));

end;

procedure TListEditor.OKButtonClick(Sender: TObject);
var
   i      : integer = 0;
begin
     {Clear location list.}
     Settings.BenchLocation.Clear;
     {Save memo to location list and update settings list combobox.}
     for i := 0 to memo.Lines.Count - 1 do
         Settings.BenchLocation.Add(EncryptString(Memo.Lines[i], CryptKey));
     {Save list file.}
     Settings.BenchLocation.SaveToFile(Settings.RemoteDrive + Settings.RemoteDirectory +
                                                            WorkbenchLocation);

     MainForm.UpdateSettingsList;
     {Close form.}
     close;
end;

procedure TListEditor.OKButtonMouseEnter(Sender: TObject);
begin
     OKButton.ImageIndex := 1;
end;

procedure TListEditor.OKButtonMouseLeave(Sender: TObject);
begin
     OKButton.ImageIndex := 0;
end;

procedure TListEditor.CancelButtonMouseEnter(Sender: TObject);
begin
     CancelButton.ImageIndex := 13;
end;

procedure TListEditor.CancelButtonClick(Sender: TObject);
begin
     close;
end;

procedure TListEditor.CancelButtonMouseLeave(Sender: TObject);
begin
     CancelButton.ImageIndex := 12;
end;

end.

